# read ini items, source ngcgui.tcl, create axis tabs
# provide tcl package Ngcgui

proc ngcgui_app_init {} {
  if {[info command inifindall] == ""} {
    return -code error "ngcgui_app_init: requires command inifindall
from axis.py (emc2.5) or \[DISPLAY\]USER_COMMAND_FILE (emc2.4)"
  }
  #[DISPLAY]TKAPP = Ngcgui
  set ngcgui           [inifindall DISPLAY NGCGUI] ;# supersede library
  set ngcgui_subfile   [inifindall DISPLAY NGCGUI_SUBFILE]
  # optional:
  set ngcgui_preamble  [inifindall DISPLAY NGCGUI_PREAMBLE]
  set ngcgui_postamble [inifindall DISPLAY NGCGUI_POSTAMBLE]
  set ngcgui_font      [inifindall DISPLAY NGCGUI_FONT]
  set ngcgui_options   [inifindall DISPLAY NGCGUI_OPTIONS]
  
  # allow specification of DISPLAY-NGCGUI for:
  #  1) compatibility with use of DISPLAY-USER_COMMAND_FILE
  #  2) allow substitition of alternate for testing
  set libngcgui [file join [file dirname [info script]] ngcgui.tcl]
  if {"$ngcgui" == ""} {
    set ngcgui $libngcgui ;# normally, use the library supplied ngcgui.tcl
  } else {
    if {"$ngcgui" != "$libngcgui"} {
      puts stderr "ngcgui_app_init: Substituting $ngcgui for $libngcgui"
    }
  }
puts "BEGIN debugging info:----------------------------------------------------------------"
catch {puts "emc=[eval exec which emc]"}
catch {puts "version=$::version"}
catch {puts "libngcgui=$libngcgui"}
catch {puts "script=[info script]"}
catch {puts "uname=[eval exec uname -a]"}
catch {puts "git branch=[eval exec git branch]"}
catch {puts "git log=[eval exec git log -5]"}
catch {puts "pwd=[pwd]"}
catch {puts "tcl_patchLevel=$::tcl_patchLevel"}
catch {puts [eval exec /bin/ls -l]}
puts vars:
foreach v [info vars ngcgui*] {
  puts "$v= [set $v]"
}
catch {puts "emcini=$::emcini"}
set msg ""
catch {eval exec cat $::emcini} msg
puts msg=<\n$msg\n>
puts "END debugging info:----------------------------------------------------------------"
  if ![file readable $ngcgui] {
    return -code error "ngcgui_app.tcl: <$ngcgui> not readable"
  }
  source $ngcgui ;# main ngcgui code 
  
  set ::ngcguict 0
  foreach fname $ngcgui_subfile {
    set wtab [dynamic_tab ngcgui$::ngcguict [file tail $fname] ] ;# axis func
    if {"$wtab" == "None"} {
      # functions of tkapp.py were incorporated in emc 2.5 27dec10 af6ae9907e1c0
      #puts "\nerrorInfo: $::errorInfo"
      puts "\nEmc version = $::version"
      puts "for emc2.5.xxx, Do not include tkapp.py in the ini file\n"
      continue
    }
    set w [frame $wtab.tframe -container 0 -borderwidth 0 -highlightthickness 0]
    pack $w -side top -fill both -expand 1 -anchor nw

    ::ngcgui::embed_in_axis_tab $w \
              subfile=$fname \
              preamble=$ngcgui_preamble \
              postamble=$ngcgui_postamble \
              font=$ngcgui_font \
              options=$ngcgui_options
    incr ::ngcguict
  }
  return
} ;# ngcgui_app_init

ngcgui_app_init  ;# sources ngcgui.tcl
rename ngcgui_app_init {} ;# no longer needed
package provide Ngcgui 1.0
